


#include <p18f2610.h>

#include <i2c.h>

#include "h/Affichages.h"
#include "h/I2C.h"
#include "h/Thermometre.h"
#include "h/Font5x7.h"
#include "h/Parametres.h"
#include "h/Utilitaires.h"



extern unsigned char g_Affichages[NOMBRE_ETAGES][NOMBRE_COLONNES];



extern unsigned char g_Sortie;



extern unsigned char g_Maintient;



extern unsigned char Mot[8];



void PositionnerCompteurs(unsigned char Etage, unsigned char Colonne)
{
	unsigned char PositionnementColonne;
	unsigned char PositionnementEtage;

	BROCHE_RAZ = 1;
	BROCHE_RAZ = 0;

		for(PositionnementEtage = 0; PositionnementEtage < Etage; PositionnementEtage++)
		{
			for(PositionnementColonne = 0; PositionnementColonne < NOMBRE_COLONNES; PositionnementColonne++)
			{
				BROCHE_VALIDATIONS = 1;
				BROCHE_VALIDATIONS = 0;
			}
		}
		for(PositionnementColonne = 0; PositionnementColonne < Colonne; PositionnementColonne++)
		{
			BROCHE_VALIDATIONS = 1;
			BROCHE_VALIDATIONS = 0;
		}
}



void Scrutation(int Maintient)
{
	unsigned char Colonne;	/* Variable qui indique  quelle colonne les donnes sont envoyes. */
	unsigned char Etage;	/* Variable qui indique  quel tage les donnes sont envoyes. */

	if(BROCHE_BOUTON_2 == 1)
	{
		g_Maintient = 0xFF;
	}

	if(BROCHE_BOUTON_1 == 1)
	{
		g_Maintient = 0x00;

		g_Sortie = 0xFF;
	}
	else
	{
		if(g_Sortie != 0xFF)
		{
			for(Etage = 0; Etage < NOMBRE_ETAGES; Etage++)
			{
				for(Colonne = 0; Colonne < NOMBRE_COLONNES; Colonne++)
				{
					/* 1) Prsenter les donnes */
					BROCHES_DONNEES = g_Affichages[Etage][Colonne];
					
					/* 2) Envoyer l'impulsion de validation */
					BROCHE_VALIDATIONS = 1;
					BROCHE_VALIDATIONS = 0;
				}
				/* 3) Une fois que 8 octets ont t envoys, activer les sorties, dsactiver les sorties, et revenir en 1) */
				BROCHE_ACTIVATIONS = 0;
				Delai(Maintient);
				BROCHE_ACTIVATIONS = 1;
			}
			/* 4) Une fois que 8 tages aient t activs, revenir en 1) */
		}
	}
}



void ScrutationsMultiples(int Nombre, int Maintient)
{
	int k;

	for(k = 0; k < Nombre; k++)
	{
		Scrutation(Maintient);
	}
}

void ScrutationReduite(int Maintient, int Coupures)
{
	unsigned char Colonne;	/* Variable qui indique  quelle colonne les donnes sont envoyes. */
	unsigned char Etage;	/* Variable qui indique  quel tage les donnes sont envoyes. */

	if(BROCHE_BOUTON_2 == 1)
	{
		g_Maintient = 0xFF;
	}

	if(BROCHE_BOUTON_1 == 1)
	{
		g_Maintient = 0x00;

		g_Sortie = 0xFF;
	}
	else
	{
		if(g_Sortie != 0xFF)
		{
			for(Etage = 0; Etage < NOMBRE_ETAGES; Etage++)
			{
				for(Colonne = 0; Colonne < NOMBRE_COLONNES; Colonne++)
				{
					/* 1) Prsenter les donnes */
					BROCHES_DONNEES = g_Affichages[Etage][Colonne];
					
					/* 2) Envoyer l'impulsion de validation */
					BROCHE_VALIDATIONS = 1;
					BROCHE_VALIDATIONS = 0;
				}
				/* 3) Une fois que 8 octets ont t envoys, activer les sorties, dsactiver les sorties, et revenir en 1) */
				BROCHE_ACTIVATIONS = 0;
				Delai(Maintient);
				BROCHE_ACTIVATIONS = 1;
				Delai(Coupures);
			}
			/* 4) Une fois que 8 tages aient t activs, revenir en 1) */
		}
	}
}



void ScrutationsReduitesMultiples(int Nombre, int Maintient, int Coupures)
{
	int k;

	for(k = 0; k < Nombre; k++)
	{
		ScrutationReduite(Maintient, Coupures);
	}
}



void ScrutationsIntensitesVariables(int Minimum, int Maximum, int Phases)
{
	int k;

	for(k = Minimum; k < Maximum; k++)
	{
		ScrutationsReduitesMultiples(Phases, k, (Maximum + 1 - k));
	}
	for(k = Maximum; k > Minimum; k--)
	{
		ScrutationsReduitesMultiples(Phases, k, (Maximum + 1 - k));
	}
}



void ActiverTranche(unsigned char Direction, unsigned char Numero, unsigned char Contenu)
{
	unsigned char k;
	unsigned char l;

		switch(Direction)
		{
			case 'X' :
			{
				for(l = 0; l < NOMBRE_ETAGES; l++)
				{
					g_Affichages[l][7 - Numero] = Contenu;
				}
				break;
			}
			case 'Y' :
			{
				for(k = 0; k < NOMBRE_ETAGES; k++)
				{
					for(l = 0; l < NOMBRE_ETAGES; l++)
					{
						if((Contenu & (1 << l)) != 0)
						{
							g_Affichages[k][l] |= (1 << Numero);
						}
					}
				}
				break;
			}
			case 'Z' :
			{
				for(l = 0; l < NOMBRE_ETAGES; l++)
				{
					g_Affichages[Numero][l] = Contenu;
				}
				break;
			}
			default :
			{
				break;
			}
		}



}



void ActiverTranche0(unsigned char Numero, unsigned char Contenu)
{
	unsigned char k;
	unsigned char l;

	unsigned char Tampon;

	for(k = 0; k < NOMBRE_ETAGES; k++)
	{
		if(k == Numero)
		{
			Tampon = Contenu;
		}
		else
		{
			Tampon = 0x00;
		}

		for(l = 0; l < NOMBRE_COLONNES; l++)
		{
			g_Affichages[k][l] = Tampon;
		}
	}
}



void ActiverTranche1(unsigned char Numero, unsigned char Contenu)
{
	unsigned char k;
	unsigned char l;

	unsigned char Tampon;

	for(k = 0; k < NOMBRE_ETAGES; k++)
	{
		for(l = 0; l < NOMBRE_COLONNES; l++)
		{
			if(l == Numero)
			{
				Tampon = Contenu;
			}
			else
			{
				Tampon = 0x00;
			}

			g_Affichages[k][l] = Tampon;
		}
	}
}



void ActiverOblique(unsigned char Orientation, unsigned char Contenu)
{
	unsigned char k;
	unsigned char l;



	switch(Orientation)
	{
		case 1 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					if(TesterPositionPariculiere(Contenu, l))
					{
						g_Affichages[l][k] |= (1 << k);	/*  |= (1 << k); */
						/* Tampon = TamponCaractere[l];
						g_Affichages[Z + l][7 - X] |= (Tampon << Y); */
					}
				}
			}
			break;
		}
		case 2 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					if(TesterPositionPariculiere(Contenu, l))
					{
						g_Affichages[l][k] |= (1 << (7 - k));	/*  |= (1 << k); */
						/* Tampon = TamponCaractere[l];
						g_Affichages[Z + l][7 - X] |= (Tampon << Y); */
					}
				}
			}
			break;
		}
		case 3 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					if(k == l)
					{
						g_Affichages[k][7 - l] = Contenu;
					}
				}
			}
			break;
		}
		case 4 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					if(k == l)
					{
						g_Affichages[k][l] = Contenu;
					}
				}
			}
			break;
		}
		case 5 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					if(TesterPositionPariculiere(Contenu, l))
					{
						g_Affichages[l][k] |= (1 << l);
						/* Tampon = TamponCaractere[l];
						g_Affichages[Z + l][7 - X] |= (Tampon << Y); */
					}
				}
			}
			break;
		}
		case 6 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					if(TesterPositionPariculiere(Contenu, l))
					{
						g_Affichages[l][k] |= (1 << (7 - l));
						/* Tampon = TamponCaractere[l];
						g_Affichages[Z + l][7 - X] |= (Tampon << Y); */
					}
				}
			}
			break;
		}
		default :
		{
			break;
		}
	}
}



void AfficherCaractere0(unsigned char Numero, unsigned char Remanence, unsigned char Caractere)
{
	unsigned char k;
	unsigned char l;

	unsigned char Tampon;

	int Endroit;

	Endroit = (5 * (((int)Caractere) - 0x20));

	for(k = 0; k < NOMBRE_ETAGES; k++)
	{
		for(l = 0; l < NOMBRE_COLONNES; l++)
		{
			if((l < 5) && (k == Numero))
			{
				Tampon = Font5x7[Endroit + l];
				g_Affichages[k][l] = Tampon;
			}
			else
			{
				if(Remanence == 0)
				{
					g_Affichages[k][l] = 0x00;
				}
			}
		}
	}
}



void AfficherCaractere1(unsigned char Numero, unsigned char Remanence, unsigned char Caractere)
{
	unsigned char k;
	unsigned char l;

	unsigned char Tampon;

	int Endroit;

	Endroit = (5 * (((int)Caractere) - 0x20));

	for(k = 0; k < NOMBRE_ETAGES; k++)
	{
		for(l = 0; l < NOMBRE_COLONNES; l++)
		{
			if((k < 5) && (l == Numero))
			{
				Tampon = Font5x7[Endroit + k];
				g_Affichages[k][l] = Tampon;
			}
			else
			{
				if(Remanence == 0)
				{
					g_Affichages[k][l] = 0x00;
				}
			}
		}
	}
}



void AllumerCube(void)
{
	unsigned char k;
	unsigned char l;

	for(k = 0; k < 8; k++)
	{
		for(l = 0; l < 8; l++)
		{
			g_Affichages[k][l] = 0xFF;
		}
	}
}



void EteindreCube(void)
{
	unsigned char k;
	unsigned char l;

	for(k = 0; k < NOMBRE_ETAGES; k++)
	{
		for(l = 0; l < NOMBRE_COLONNES; l++)
		{
			g_Affichages[k][l] = 0x00;
		}
	}
}



void AfficherPoint(unsigned char X, unsigned char Y, unsigned char Z)
{
	g_Affichages[Z][(7 - X)] |= (1 << Y);
}



void EteindrePoint(unsigned char X, unsigned char Y, unsigned char Z)
{
	g_Affichages[Z][(7 - X)] &= (~(1 << Y));
}



void AfficherLigne(unsigned char X, unsigned char Y, unsigned char Z, unsigned char Longueur, unsigned char Orientation)
{
	unsigned char k;

	switch(Orientation)
	{
		case 'X' :
		{
			for(k = 0; k < Longueur; k++)
			{
				AfficherPoint((X + k), Y, Z);
			}
			break;
		}
		case 'Y' :
		{
			for(k = 0; k < Longueur; k++)
			{
				AfficherPoint(X, (Y + k), Z);
			}
			break;
		}
		case 'Z' :
		{
			for(k = 0; k < Longueur; k++)
			{
				AfficherPoint(X, Y, (Z + k));
			}
			break;
		}
		default :
		{
			break;
		}
	}
}



void AfficherLigneOblique(unsigned char X, unsigned char Y, unsigned char Z, unsigned char Longueur, unsigned char Orientation, unsigned char Miroir)
{
	unsigned char k;

	if(Miroir == 0)
	{
		switch(Orientation)
		{
			case 'X' :
			{
				for(k = 0; k < Longueur; k++)
				{
					AfficherPoint(X, (Y + k), (Z + k));
				}
				break;
			}
			case 'Y' :
			{
				for(k = 0; k < Longueur; k++)
				{
					AfficherPoint((X + k), Y, (Z + k));
				}
				break;
			}
			case 'Z' :
			{
				for(k = 0; k < Longueur; k++)
				{
					AfficherPoint((X + k), (Y + k), Z);
				}
				break;
			}
			default :
			{
				break;
			}
		}
	}
	else
	{
		switch(Orientation)
		{
			case 'X' :
			{
				for(k = 0; k < Longueur; k++)
				{
					AfficherPoint(X, (Y + k), (Z - k));
				}
				break;
			}
			case 'Y' :
			{
				for(k = 0; k < Longueur; k++)
				{
					AfficherPoint((X + k), Y, (Z - k));
				}
				break;
			}
			case 'Z' :
			{
				for(k = 0; k < Longueur; k++)
				{
					AfficherPoint((X - k), (Y + k), Z);
				}
				break;
			}
			default :
			{
				break;
			}
		}
	}


}



void AfficherCoin(unsigned char Arete, unsigned char Orientation, unsigned char Volume)
{
	switch(Orientation)
	{
		case 1 :
		{
			if((0x01 & Volume) == 0x01)
			{
				AfficherLigne(0, 0, 0, Arete, 'Y');
				AfficherLigne(0, 0, 0, Arete, 'X');
				AfficherLigne(0, 0, 0, Arete, 'Z');
			}
		
			if((0x02 & Volume) == 0x02)
			{
				AfficherLigneOblique(0, 0, (Arete - 1), Arete, 'X', 1);
				AfficherLigneOblique(0, 0, (Arete - 1), Arete, 'Y', 1);
				AfficherLigneOblique((Arete - 1), 0, 0, Arete, 'Z', 1);
			}

			break;
		}
		case 2 :
		{
			if((0x01 & Volume) == 0x01)
			{
				AfficherLigne(0, (8 - Arete), 0, Arete, 'Y');
				AfficherLigne(0, 7, 0, Arete, 'X');
				AfficherLigne(0, 7, 0, Arete, 'Z');
			}
		
			if((0x02 & Volume) == 0x02)
			{
				AfficherLigneOblique(0, (8 - Arete), 0, Arete, 'X', 0);
				AfficherLigneOblique(0, 7, (Arete - 1), Arete, 'Y', 1);
				AfficherLigneOblique(0, (8 - Arete), 0, Arete, 'Z', 0);
			}

			break;
		}
		case 3 :
		{
			if((0x01 & Volume) == 0x01)
			{
				AfficherLigne(7, 0, 0, Arete, 'Y');
				AfficherLigne((8 - Arete), 0, 0, Arete, 'X');
				AfficherLigne(7, 0, 0, Arete, 'Z');
			}
		
			if((0x02 & Volume) == 0x02)
			{
				AfficherLigneOblique(7, 0, (Arete - 1), Arete, 'X', 1);
				AfficherLigneOblique((8 - Arete), 0, 0, Arete, 'Y', 0);
				AfficherLigneOblique((8 - Arete), 0, 0, Arete, 'Z', 0);
			}

			break;
		}
		case 4 :
		{
			if((0x01 & Volume) == 0x01)
			{
				AfficherLigne(7, (8 - Arete), 0, Arete, 'Y');
				AfficherLigne((8 - Arete), 7, 0, Arete, 'X');
				AfficherLigne(7, 7, 0, Arete, 'Z');
			}
		
			if((0x02 & Volume) == 0x02)
			{
				AfficherLigneOblique(7, (8 - Arete), 0, Arete, 'X', 0);
				AfficherLigneOblique((8 - Arete), 7, 0, Arete, 'Y', 0);
				AfficherLigneOblique(7, (8 - Arete), 0, Arete, 'Z', 1);
			}

			break;
		}
		case 5 :
		{
			if((0x01 & Volume) == 0x01)
			{
				AfficherLigne(0, 0, 7, Arete, 'Y');
				AfficherLigne(0, 0, 7, Arete, 'X');
				AfficherLigne(0, 0, (8 - Arete), Arete, 'Z');
			}
		
			if((0x02 & Volume) == 0x02)
			{
				AfficherLigneOblique(0, 0, (8 - Arete), Arete, 'X', 0);
				AfficherLigneOblique(0, 0, (8 - Arete), Arete, 'Y', 0);
				AfficherLigneOblique((Arete - 1), 0, 7, Arete, 'Z', 1);
			}

			break;
		}
		case 6 :
		{
			if((0x01 & Volume) == 0x01)
			{
				AfficherLigne(0, (8 - Arete), 7, Arete, 'Y');
				AfficherLigne(0, 7, 7, Arete, 'X');
				AfficherLigne(0, 7, (8 - Arete), Arete, 'Z');
			}
		
			if((0x02 & Volume) == 0x02)
			{
				AfficherLigneOblique(0, (8 - Arete), 7, Arete, 'X', 1);
				AfficherLigneOblique(0, 7, (8 - Arete), Arete, 'Y', 0);
				AfficherLigneOblique(0, (8 - Arete), 7, Arete, 'Z', 0);
			}

			break;
		}
		case 7 :
		{
			if((0x01 & Volume) == 0x01)
			{
				AfficherLigne(7, 0, 7, Arete, 'Y');
				AfficherLigne((8 - Arete), 0, 7, Arete, 'X');
				AfficherLigne(7, 0, (8 - Arete), Arete, 'Z');
			}
		
			if((0x02 & Volume) == 0x02)
			{
				AfficherLigneOblique(7, 0, (8 - Arete), Arete, 'X', 0);
				AfficherLigneOblique((8 - Arete), 0, 7, Arete, 'Y', 1);
				AfficherLigneOblique((8 - Arete), 0, 7, Arete, 'Z', 0);
			}

			break;
		}
		case 8 :
		{
			if((0x01 & Volume) == 0x01)
			{
				AfficherLigne(7, (8 - Arete), 7, Arete, 'Y');
				AfficherLigne((8 - Arete), 7, 7, Arete, 'X');
				AfficherLigne(7, 7, (8 - Arete), Arete, 'Z');
			}
		
			if((0x02 & Volume) == 0x02)
			{
				AfficherLigneOblique(7, (8 - Arete), 7, Arete, 'X', 1);
				AfficherLigneOblique((8 - Arete), 7, 7, Arete, 'Y', 1);
				AfficherLigneOblique(7, (8 - Arete), 7, Arete, 'Z', 1);
			}

			break;
		}
		default:
		{
			break;
		}
	}
}



void AfficherParallelepipede(unsigned char X, unsigned char Y, unsigned char Z, unsigned char A, unsigned char B, unsigned char C)
{
	unsigned char k;

	if((X < 0) || (X > 7))
	{
		X = 0;
	}

	if((Y < 0) || (Y > 7))
	{
		Y = 0;
	}

	if((Z < 0) || (Z > 7))
	{
		Z = 0;
	}

	if((A < 1) || (A > 8))
	{
		A = 1;
	}

	if((B < 1) || (B > 8))
	{
		B = 1;
	}

	if((C < 1) || (C > 8))
	{
		C = 1;
	}

	for(k = 0; k < A; k++)
	{
		AfficherPoint((X + k), Y, Z);
	}	

	for(k = 0; k < B; k++)
	{
		AfficherPoint(X, (Y + k), Z);
	}

	for(k = 0; k < C; k++)
	{
		AfficherPoint(X, Y, (Z + k));
	}

	for(k = 0; k < A; k++)
	{
		AfficherPoint((X + k), Y, (Z + C - 1));
	}

	for(k = 0; k < A; k++)
	{
		AfficherPoint((X + k), (Y + B - 1), Z);
	}

	for(k = 0; k < A; k++)
	{
		AfficherPoint((X + k), (Y + B - 1), (Z + C - 1));
	}

	for(k = 0; k < B; k++)
	{
		AfficherPoint(X, (Y + k), (Z + C - 1));
	}

	for(k = 0; k < B; k++)
	{
		AfficherPoint((X + A - 1), (Y + k), Z);
	}

	for(k = 0; k < B; k++)
	{
		AfficherPoint((X + A - 1), (Y + k), (Z + C - 1));
	}

	for(k = 0; k < C; k++)
	{
		AfficherPoint(X, (Y + B - 1), (Z + k));
	}

	for(k = 0; k < C; k++)
	{
		AfficherPoint((X + A - 1), Y, (Z + k));
	}

	for(k = 0; k < C; k++)
	{
		AfficherPoint((X + A - 1), (Y + B - 1), (Z + k));
	}
}



void AfficherCaractere(char X, char Y, char Z, unsigned char Orientation, unsigned char Rotation, unsigned char Miroir, unsigned char Caractere)
{
	unsigned char k;
	unsigned char l;

	unsigned char Tampon;

	unsigned char TamponCaractere[8] = {0x00};

	int Endroit;



	Endroit = (8 * (((int)Caractere) - 0x20));



	if(Orientation == 'X')
	{
		switch(Rotation)
		{
			case 0 :
			{
				Rotation = 1;
				break;
			}
			case 1 :
			{
				Rotation = 0;
				break;
			}
			case 2 :
			{
				Rotation = 3;
				break;
			}
			case 3 :
			{
				Rotation = 2;
				break;
			}
			default :
			{
				break;
			}
		}
	}



	for(k = 0; k < 8; k++)
	{
		switch(Rotation)
		{
			case 0 :
			{
				TamponCaractere[k] = Font5x7[Endroit + k];
				break;
			}
			case 1 :
			{
				for(l = 0; l < 8; l++)
				{
					TamponCaractere[7 - l] |= (TesterPositionPariculiere(Font5x7[Endroit + k], l) << k);
				}
				break;
			}
			case 2 :
			{
				TamponCaractere[7 - k] = Retourner(Font5x7[Endroit + k]);
				break;
			}
			case 3 :
			{
				for(l = 0; l < 8; l++)
				{
					TamponCaractere[l] |= (TesterPositionPariculiere(Font5x7[Endroit + (7 - k)], l) << k);
				}
				break;
			}
			default :
			{
	
				break;
			}
		}
	}

	if(Miroir == 1)
	{
		Tampon = TamponCaractere[7];
		TamponCaractere[7] = TamponCaractere[0];
		TamponCaractere[0] = Tampon;

		Tampon = TamponCaractere[6];
		TamponCaractere[6] = TamponCaractere[1];
		TamponCaractere[1] = Tampon;

		Tampon = TamponCaractere[5];
		TamponCaractere[5] = TamponCaractere[2];
		TamponCaractere[2] = Tampon;

		Tampon = TamponCaractere[4];
		TamponCaractere[4] = TamponCaractere[3];
		TamponCaractere[3] = Tampon;
	}

	switch(Orientation)
	{
		case 'X' :
		{
			for(l = 0; l < NOMBRE_COLONNES; l++)
			{
				Tampon = TamponCaractere[l];
				g_Affichages[Z + l][7 - X] |= (Tampon << Y);
			}
			break;
		}
		case 'Y' :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					Tampon = TamponCaractere[k];
					g_Affichages[Z + (7 - l)][(7 - k) - X] |= (((Tampon & (1 << l)) >> l) << Y);
				}
			}
			break;
		}
		case 'Z' :
		{
			for(l = 0; l < NOMBRE_COLONNES; l++)
			{
				Tampon = Retourner(TamponCaractere[l]);
				if(Y >= 0)
				{
					g_Affichages[Z][(7 - l) - X] |= (Tampon << Y);
				}
				else
				{
					g_Affichages[Z][(7 - l) - X] |= (Tampon >> (-Y));
				}
			}
			break;
		}
		default :
		{
			break;
		}
	}
}



void AfficherCaractereOblique(char X, char Y, unsigned char Orientation, unsigned char Rotation, unsigned char Miroir, unsigned char Caractere)
{
	unsigned char k;
	unsigned char l;

	unsigned char Tampon;

	unsigned char TamponCaractere[8] = {0x00};

	int Endroit;



	Endroit = (8 * (((int)Caractere) - 0x20));



	if(Orientation == 5)
	{
		switch(Rotation)
		{
			case 0 :
			{
				Rotation = 2;
				break;
			}
			case 1 :
			{
				Rotation = 1;
				break;
			}
			case 2 :
			{
				Rotation = 0;
				break;
			}
			case 3 :
			{
				Rotation = 3;
				break;
			}
			default :
			{
				break;
			}
		}
	}



	for(k = 0; k < 8; k++)
	{
		switch(Rotation)
		{
			case 0 :
			{
				TamponCaractere[k] = Font5x7[Endroit + k];
				break;
			}
			case 1 :
			{
				for(l = 0; l < 8; l++)
				{
					TamponCaractere[7 - l] |= (TesterPositionPariculiere(Font5x7[Endroit + k], l) << k);
				}
				break;
			}
			case 2 :
			{
				TamponCaractere[7 - k] = Retourner(Font5x7[Endroit + k]);
				break;
			}
			case 3 :
			{
				for(l = 0; l < 8; l++)
				{
					TamponCaractere[l] |= (TesterPositionPariculiere(Font5x7[Endroit + (7 - k)], l) << k);
				}
				break;
			}
			default :
			{
	
				break;
			}
		}
	}

	if(Miroir == 1)
	{
		Tampon = TamponCaractere[7];
		TamponCaractere[7] = TamponCaractere[0];
		TamponCaractere[0] = Tampon;

		Tampon = TamponCaractere[6];
		TamponCaractere[6] = TamponCaractere[1];
		TamponCaractere[1] = Tampon;

		Tampon = TamponCaractere[5];
		TamponCaractere[5] = TamponCaractere[2];
		TamponCaractere[2] = Tampon;

		Tampon = TamponCaractere[4];
		TamponCaractere[4] = TamponCaractere[3];
		TamponCaractere[3] = Tampon;
	}

	switch(Orientation)
	{
		case 1 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					Tampon = TamponCaractere[k + X];
					if(TesterPositionPariculiere(Tampon, l))
					{
						g_Affichages[Y + l][k] |= (1 << k);	/*  |= (1 << k); */
						/* Tampon = TamponCaractere[l];
						g_Affichages[Z + l][7 - X] |= (Tampon << Y); */
					}
				}
			}
			break;
		}
		case 2 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					Tampon = TamponCaractere[k + X];
					if(TesterPositionPariculiere(Tampon, l))
					{
						g_Affichages[Y + l][k] |= (1 << (7 - k));	/*  |= (1 << k); */
						/* Tampon = TamponCaractere[l];
						g_Affichages[Z + l][7 - X] |= (Tampon << Y); */
					}
				}
			}
			break;
		}
		case 3 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					Tampon = TamponCaractere[k];
					if(k == l)
					{
						g_Affichages[Y + k][X + (7 - l)] = Tampon;
					}
				}
			}
			break;
		}
		case 4 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					Tampon = TamponCaractere[Y + k];
					if(k == l)
					{
						g_Affichages[k][X + l] = Tampon;
					}
				}
			}
			break;
		}
		case 5 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					Tampon = TamponCaractere[k];
					if(TesterPositionPariculiere(Tampon, (l - Y)))
					{
						g_Affichages[l][k - X] |= (1 << l);
						/* Tampon = TamponCaractere[l];
						g_Affichages[Z + l][7 - X] |= (Tampon << Y); */
					}
				}
			}
			break;
		}
		case 6 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					Tampon = TamponCaractere[k];
					if(TesterPositionPariculiere(Tampon, (l - Y)))
					{
						g_Affichages[l][k - X] |= (1 << (7 - l));
						/* Tampon = TamponCaractere[l];
						g_Affichages[Z + l][7 - X] |= (Tampon << Y); */
					}
				}
			}
			break;
		}
		default :
		{
			break;
		}
	}
}



void ConvertirAfficherGraphique(int Nombre, unsigned char Base, unsigned char Attribut)
{
	int k = 0;     		        /* Compteur. */


	int l = 0;

	unsigned char Hexadecimaux[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'}; 

	unsigned char Tampon[32];

	if(Nombre < 0)	/* Si le nombre  convertir et  afficher est strictement ngatif */
	{
		Nombre = (-Nombre);
		Mot[0] = '-';	/* Affichage du signe  Moins  */
	}

	/* Remplissage de  Tampon  par le code ASCII du rsultat de l'opration (Nombre % Base),
	grce  la constante  Hexadecimaux  dPositifare en en-tte de ce fichier */
	do
	{
		Tampon[k] = Hexadecimaux[Nombre % Base];    /* Conversion Hexadcimale / ASCII de la fin de la chane de caractres vers le dbut. */
		Nombre = (Nombre / Base);
		k++;
	}
	while(Nombre > 0);  



	l = k;

 			

	/* Affichage le contenu de  Tampon , de la fin vers le dbut et caractre par caractre, 
	directement dans la RAM du LCD. */
	do
	{
		k--;
		Mot[k] = Tampon[l - k - 1];
	}
	while(k > 0);
}


