


#include "h/Effets.h"
#include "h/Affichages.h"


const rom unsigned char CoordonneesX[60] = {0, 1, 2, 3, 4, 5, 5, 6, 7, 7, 7, 6, 6, 5, 4, 3, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 5, 4, 3, 2, 1, 1, 2, 3, 4, 4, 5, 6, 7, 7, 7, 7};
const rom unsigned char CoordonneesY[60] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 4, 5, 6, 6, 6, 6, 5, 4, 3, 2, 1, 1, 2, 3, 3, 2, 2, 3, 4, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7, 6, 6, 6, 6, 5, 5, 5, 5, 6, 7, 7};
const rom unsigned char CoordonneesZ[60] = {0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7};

const rom unsigned char Tailles0[64] = {1, 2, 3, 4, 5, 6, 7, 8, 5, 6, 1, 2, 3, 7, 5, 8, 6, 4, 1, 1, 3, 6, 5, 5, 4, 4, 1, 2, 3, 8, 8, 7, 1, 3, 6, 4, 6, 4, 4, 4, 5, 6, 2, 2, 3, 5, 4, 2, 5, 6, 3, 1, 2, 8, 4, 6, 8, 6, 2, 6, 2, 3, 2, 1};
const rom unsigned char Tailles1[64] = {1, 4, 5, 6, 3, 2, 2, 4, 1, 8, 7, 8, 2, 5, 6, 2, 3, 4, 3, 7, 2, 7, 7, 7, 5, 6, 2, 2, 1, 4, 4, 7, 8, 1, 2, 5, 6, 4, 4, 1, 5, 6, 7, 8, 6, 3, 5, 6, 6, 4, 2, 3, 7, 8, 2, 1, 4, 3, 4, 5, 6, 2, 6, 1};
const rom unsigned char Tailles2[64] = {1, 3, 3, 4, 5, 3, 4, 8, 5, 6, 1, 2, 3, 7, 5, 8, 6, 4, 1, 1, 3, 6, 5, 5, 4, 8, 1, 2, 7, 8, 8, 7, 1, 3, 6, 4, 6, 4, 4, 4, 5, 6, 2, 2, 3, 5, 4, 6, 5, 6, 3, 1, 2, 8, 4, 6, 5, 6, 2, 6, 3, 3, 2, 1};
const rom unsigned char Tailles3[64] = {1, 4, 3, 8, 5, 7, 1, 8, 5, 6, 1, 5, 3, 7, 5, 8, 6, 4, 1, 1, 3, 6, 5, 2, 4, 3, 1, 4, 3, 8, 5, 7, 1, 3, 6, 4, 6, 4, 7, 4, 5, 6, 2, 7, 3, 5, 4, 2, 5, 6, 3, 1, 2, 8, 4, 6, 8, 6, 9, 6, 2, 3, 2, 1};



void RemplirTranches(unsigned char Phases, unsigned char Direction, unsigned char Transitions)
{
	unsigned char k;
	unsigned char l;

	EteindreCube();

	for(k = 0; k < 8; k++)
	{
		ActiverTranche(Direction, k, 0xFF);

		for(l = 0; l < Phases; l++)
		{
			Scrutation(90);
		}
	}

	EteindreCube();
}



void CroiserTranches(unsigned char Phases, unsigned char Transitions)
{
	unsigned char k;
	unsigned char l;

		for(k = 0; k < 8; k++)
		{
			EteindreCube();

			ActiverTranche('X', k, 0xFF);
			ActiverTranche('Y', k, 0xFF);

			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 0; k < 8; k++)
		{
			EteindreCube();

			ActiverTranche('X', k, 0xFF);
			ActiverTranche('Z', k, 0xFF);

			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 0; k < 8; k++)
		{
			EteindreCube();

			ActiverTranche('Y', k, 0xFF);
			ActiverTranche('Z', k, 0xFF);

			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
}



void BalayerTranches(unsigned char Phases, unsigned char Direction, unsigned char Transitions)
{
	unsigned char k;
	unsigned char l;

	EteindreCube();

	for(k = 0; k < 8; k++)
	{
		EteindreCube();

		ActiverTranche(Direction, k, 0xFF);

		for(l = 0; l < Phases; l++)
		{
			Scrutation(90);
		}
	}

	EteindreCube();
}



void EffetSurfaces(unsigned char Phases, unsigned char Transitions)
{
	unsigned char l;
	unsigned char v;

	EteindreCube();

		for(v = 0; v < 2; v++)
		{
			AfficherLigne(0, v, 0, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(0, v, 1, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(1, v, 1, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(1, v, 2, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(2, v, 2, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(2, v, 3, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(3, v, 3, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(4, v, 3, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(4, v, 4, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(4, v, 5, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(5, v, 5, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(6, v, 5, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(7, v, 5, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(7, v, 6, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
		for(v = 0; v < 2; v++)
		{
			AfficherLigne(7, v, 7, 5, 'Y');
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

	EteindreCube();
}



void EffetLignes(unsigned char Phases, unsigned char Transitions)
{
	unsigned char l;
	unsigned char v;

	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(0, v, 0, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(0, v, 1, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(1, v, 1, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(1, v, 2, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(2, v, 2, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(2, v, 3, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(3, v, 3, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(4, v, 3, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(4, v, 4, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(4, v, 5, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(5, v, 5, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(6, v, 5, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(7, v, 5, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
			}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(7, v, 6, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	for(v = 0; v < 2; v++)
	{
	EteindreCube();
		AfficherLigne(7, v, 7, 5, 'Y');
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	
	EteindreCube();
}



void EffetSerpent(unsigned char Phases, unsigned char Transitions)
{
	unsigned char k;
	unsigned char l;
	unsigned char v;



	EteindreCube();



	for(k = 0; k < 7; k++)
	{
		AfficherPoint(CoordonneesX[k], CoordonneesY[k], CoordonneesZ[k]);
		ScrutationsMultiples(Phases, Transitions);
	}


	for(l = 7; l < 60; l++)
	{
		EteindrePoint(CoordonneesX[l - 7], CoordonneesY[l - 7], CoordonneesZ[l - 7]);
		AfficherPoint(CoordonneesX[l], CoordonneesY[l], CoordonneesZ[l]);
		ScrutationsMultiples(Phases, Transitions);
	}



	for(v = 53; v < 60; v++)
	{
		EteindrePoint(CoordonneesX[v], CoordonneesY[v], CoordonneesZ[v]);
		ScrutationsMultiples(Phases, Transitions);
	}



	EteindreCube();
}



void EffetCoins(unsigned char Phases, unsigned char Arete, unsigned char Volume, unsigned char Transitions)
{
	unsigned char k;

	EteindreCube();



	for(k = 1; k <= 8; k++)
	{
		AfficherCoin(Arete, k, Volume);
	}



	ScrutationsMultiples(Phases, Transitions);



	EteindreCube();
}



void EffetGrosseHelice(unsigned char Phases, unsigned char Direction, unsigned char Transitions)
{
	unsigned char k;

	EteindreCube();
	
	for(k = 0; k < 2; k++)
	{
		AfficherLigne((0 + k), 0, 3, 8, 'Y');
		AfficherLigne((0 + k), 0, 4, 8, 'Y');
	}
	
	
	ScrutationsMultiples(Phases, Transitions);
	
	
	EteindreCube();
	
	for(k = 0; k < 2; k++)
	{
		AfficherLigneOblique((1 + k), 1, 0, 7, 'X', 0);
		AfficherLigneOblique((1 + k), 0, 1, 7, 'X', 0);
	}
	
	ScrutationsMultiples(Phases, Transitions);
	
	
	EteindreCube();
	
	for(k = 0; k < 2; k++)
	{
		AfficherLigne((2 + k), 3, 0, 8, 'Z');
		AfficherLigne((2 + k), 4, 0, 8, 'Z');
	}
	
	ScrutationsMultiples(Phases, Transitions);
	
	
	EteindreCube();
	
	for(k = 0; k < 2; k++)
	{
		AfficherLigneOblique((3 + k), 0, 6, 7, 'X', 1);
		AfficherLigneOblique((3 + k), 1, 7, 7, 'X', 1);
	}
	
	ScrutationsMultiples(Phases, Transitions);
	
	
	EteindreCube();
	
	for(k = 0; k < 2; k++)
	{
		AfficherLigne((4 + k), 0, 3, 8, 'Y');
		AfficherLigne((4 + k), 0, 4, 8, 'Y');
	}
	
	ScrutationsMultiples(Phases, Transitions);
	
	EteindreCube();
	
	for(k = 0; k < 2; k++)
	{
		AfficherLigneOblique((5 + k), 1, 0, 7, 'X', 0);
		AfficherLigneOblique((5 + k), 0, 1, 7, 'X', 0);
	}
	
	ScrutationsMultiples(Phases, Transitions);
	
	
	EteindreCube();
	
	for(k = 0; k < 2; k++)
	{
		AfficherLigne((6 + k), 3, 0, 8, 'Z');
		AfficherLigne((6 + k), 4, 0, 8, 'Z');
	}
	
	ScrutationsMultiples(Phases, Transitions);
	
	
	EteindreCube();
	
	AfficherLigneOblique(7, 0, 6, 7, 'X', 1);
	AfficherLigneOblique(7, 1, 7, 7, 'X', 1);
	
	ScrutationsMultiples(Phases, Transitions);
}



void EffetPetitesHelices(unsigned char Phases, unsigned char Direction, unsigned char Transitions)
{
	EteindreCube();


	AfficherLigne(0, 0, 1, 3, 'Y');
	AfficherLigne(0, 5, 1, 3, 'Y');
	AfficherLigne(0, 0, 5, 3, 'Y');
	AfficherLigne(0, 5, 6, 3, 'Y');

	ScrutationsMultiples(Phases, Transitions);


	EteindreCube();


	AfficherLigneOblique(1, 0, 0, 3, 'X', 0);
	AfficherLigneOblique(1, 5, 0, 3, 'X', 0);
	AfficherLigneOblique(1, 0, 5, 3, 'X', 0);
	AfficherLigneOblique(1, 5, 5, 3, 'X', 0);

	ScrutationsMultiples(Phases, Transitions);


	EteindreCube();

	AfficherLigne(2, 1, 0, 3, 'Z');
	AfficherLigne(2, 6, 0, 3, 'Z');
	AfficherLigne(2, 1, 5, 3, 'Z');
	AfficherLigne(2, 6, 5, 3, 'Z');


	ScrutationsMultiples(Phases, Transitions);


	EteindreCube();

	AfficherLigneOblique(3, 0, 2, 3, 'X', 1);
	AfficherLigneOblique(3, 5, 2, 3, 'X', 1);
	AfficherLigneOblique(3, 0, 7, 3, 'X', 1);
	AfficherLigneOblique(3, 5, 7, 3, 'X', 1);

	ScrutationsMultiples(Phases, Transitions);


	EteindreCube();


	AfficherLigne(4, 0, 1, 3, 'Y');
	AfficherLigne(4, 5, 1, 3, 'Y');
	AfficherLigne(4, 0, 5, 3, 'Y');
	AfficherLigne(4, 5, 6, 3, 'Y');

	ScrutationsMultiples(Phases, Transitions);


	EteindreCube();


	AfficherLigneOblique(5, 0, 0, 3, 'X', 0);
	AfficherLigneOblique(5, 5, 0, 3, 'X', 0);
	AfficherLigneOblique(5, 0, 5, 3, 'X', 0);
	AfficherLigneOblique(5, 5, 5, 3, 'X', 0);

	ScrutationsMultiples(Phases, Transitions);


	EteindreCube();

	AfficherLigne(6, 1, 0, 3, 'Z');
	AfficherLigne(6, 6, 0, 3, 'Z');
	AfficherLigne(6, 1, 5, 3, 'Z');
	AfficherLigne(6, 6, 5, 3, 'Z');


	ScrutationsMultiples(Phases, Transitions);


	EteindreCube();

	AfficherLigneOblique(7, 0, 2, 3, 'X', 1);
	AfficherLigneOblique(7, 5, 2, 3, 'X', 1);
	AfficherLigneOblique(7, 0, 7, 3, 'X', 1);
	AfficherLigneOblique(7, 5, 7, 3, 'X', 1);

	ScrutationsMultiples(Phases, Transitions);


	EteindreCube();
}



void EffetCubeCentre(unsigned char Phases, unsigned char Direction, unsigned char Transitions)
{
	unsigned char l;

	if(Direction == 0)
	{
		EteindreCube();
		AfficherParallelepipede(0, 0, 0, 8, 8, 8);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(1, 1, 1, 6, 6, 6);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(2, 2, 2, 4, 4, 4);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(3, 3, 3, 2, 2, 2);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
	else
	{
		EteindreCube();
		AfficherParallelepipede(3, 3, 3, 2, 2, 2);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(2, 2, 2, 4, 4, 4);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(1, 1, 1, 6, 6, 6);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(0, 0, 0, 8, 8, 8);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
	}
}



void EffetCubeVariable(unsigned char Phases, unsigned char Arete, unsigned char Transitions)
{
	unsigned char k;
	unsigned char l;

		for(k = 1; k <= 8; k++)
		{
			EteindreCube();
			AfficherParallelepipede(0, 0, 0, k, k, k);
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 1; k < 8; k++)
		{
			EteindreCube();
			AfficherParallelepipede(k, k, k, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 7; k > 0; k--)
		{
			EteindreCube();
			AfficherParallelepipede(k, k, k, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 8; k > 0; k--)
		{
			EteindreCube();
			AfficherParallelepipede(0, 0, 0, k, k, k);
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 1; k <= 8; k++)
		{
			EteindreCube();
			AfficherParallelepipede(0, 0, 0, k, k, k);
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 1; k < 8; k++)
		{
			EteindreCube();
			AfficherParallelepipede(0, k, k, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 7; k > 0; k--)
		{
			EteindreCube();
			AfficherParallelepipede(0, k, k, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 0; k < 8; k++)
		{
			EteindreCube();
			AfficherParallelepipede(k, 0, 0, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 7; k > 0; k--)
		{
			EteindreCube();
			AfficherParallelepipede(k, 0, 0, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 0; k < 8; k++)
		{
			EteindreCube();
			AfficherParallelepipede(0, k, 0, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 7; k > 0; k--)
		{
			EteindreCube();
			AfficherParallelepipede(0, k, 0, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 0; k < 8; k++)
		{
			EteindreCube();
			AfficherParallelepipede(k, 0, k, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 7; k > 0; k--)
		{
			EteindreCube();
			AfficherParallelepipede(k, 0, k, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 0; k < 8; k++)
		{
			EteindreCube();
			AfficherParallelepipede(k, k, 0, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 7; k > 0; k--)
		{
			EteindreCube();
			AfficherParallelepipede(k, k, 0, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 0; k < 8; k++)
		{
			EteindreCube();
			AfficherParallelepipede(0, 0, k, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 7; k > 0; k--)
		{
			EteindreCube();
			AfficherParallelepipede(0, 0, k, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 0; k < 8; k++)
		{
			EteindreCube();
			AfficherParallelepipede(0, 0, 0, (8 - k), (8 - k), (8 - k));
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
}



void EffetPointsVariables(unsigned char Phases, unsigned char Nombres, unsigned char Transitions)
{
	unsigned char k;



		EteindrePoint((Tailles0[63] - 1), (Tailles1[63] - 1), (Tailles2[63] - 1));
		ScrutationsMultiples(Phases, Transitions);

		AfficherPoint((Tailles0[0] - 1), (Tailles1[0] - 1), (Tailles2[0] - 1));
		ScrutationsMultiples(Phases, Transitions);



		EteindrePoint((Tailles1[63] - 1), (Tailles2[63] - 1), (Tailles3[63] - 1));
		ScrutationsMultiples(Phases, Transitions);

		AfficherPoint((Tailles1[0] - 1), (Tailles2[0] - 1), (Tailles3[0] - 1));
		ScrutationsMultiples(Phases, Transitions);



		EteindrePoint((Tailles2[63] - 1), (Tailles3[63] - 1), (Tailles0[63] - 1));
		ScrutationsMultiples(Phases, Transitions);

		AfficherPoint((Tailles2[0] - 1), (Tailles3[0] - 1), (Tailles0[0] - 1));
		ScrutationsMultiples(Phases, Transitions);



		EteindrePoint((Tailles3[63] - 1), (Tailles0[63] - 1), (Tailles1[63] - 1));
		ScrutationsMultiples(Phases, Transitions);

		AfficherPoint((Tailles3[0] - 1), (Tailles0[0] - 1), (Tailles1[0] - 1));
		ScrutationsMultiples(Phases, Transitions);



		EteindrePoint((Tailles0[63] - 1), (Tailles2[63] - 1), (Tailles3[63] - 1));
		ScrutationsMultiples(Phases, Transitions);

		AfficherPoint((Tailles0[0] - 1), (Tailles2[0] - 1), (Tailles3[0] - 1));
		ScrutationsMultiples(Phases, Transitions);



		EteindrePoint((Tailles1[63] - 1), (Tailles2[63] - 1), (Tailles0[63] - 1));
		ScrutationsMultiples(Phases, Transitions);

		AfficherPoint((Tailles1[0] - 1), (Tailles2[0] - 1), (Tailles0[0] - 1));
		ScrutationsMultiples(Phases, Transitions);



		EteindrePoint((Tailles2[63] - 1), (Tailles0[63] - 1), (Tailles3[63] - 1));
		ScrutationsMultiples(Phases, Transitions);

		AfficherPoint((Tailles2[0] - 1), (Tailles0[0] - 1), (Tailles3[0] - 1));
		ScrutationsMultiples(Phases, Transitions);



	for(k = 1; k < 64; k++)
	{
		EteindrePoint((Tailles0[k - 1] - 1), (Tailles1[k - 1] - 1), (Tailles2[k - 1] - 1));
		ScrutationsMultiples(Phases, Transitions);

		AfficherPoint((Tailles0[k] - 1), (Tailles1[k] - 1), (Tailles2[k] - 1));
		ScrutationsMultiples(Phases, Transitions);



		EteindrePoint((Tailles1[k - 1] - 1), (Tailles2[k - 1] - 1), (Tailles3[k - 1] - 1));
		ScrutationsMultiples(Phases, Transitions);

		AfficherPoint((Tailles1[k] - 1), (Tailles2[k] - 1), (Tailles3[k] - 1));
		ScrutationsMultiples(Phases, Transitions);



		EteindrePoint((Tailles2[k - 1] - 1), (Tailles3[k - 1] - 1), (Tailles0[k - 1] - 1));
		ScrutationsMultiples(Phases, Transitions);

		AfficherPoint((Tailles2[k] - 1), (Tailles3[k] - 1), (Tailles0[k] - 1));
		ScrutationsMultiples(Phases, Transitions);



		EteindrePoint((Tailles3[k - 1] - 1), (Tailles0[k - 1] - 1), (Tailles1[k - 1] - 1));
		ScrutationsMultiples(Phases, Transitions);

		AfficherPoint((Tailles3[k] - 1), (Tailles0[k] - 1), (Tailles1[k] - 1));
		ScrutationsMultiples(Phases, Transitions);



		if(Phases != 7)
		{
	
			EteindrePoint((Tailles0[k - 1] - 1), (Tailles2[k - 1] - 1), (Tailles3[k - 1] - 1));
			ScrutationsMultiples(Phases, Transitions);
	
			AfficherPoint((Tailles0[k] - 1), (Tailles2[k] - 1), (Tailles3[k] - 1));
			ScrutationsMultiples(Phases, Transitions);

	
	
			EteindrePoint((Tailles0[k - 1] - 1), (Tailles2[k - 1] - 1), (Tailles3[k - 1] - 1));
			ScrutationsMultiples(Phases, Transitions);
	
			AfficherPoint((Tailles0[k] - 1), (Tailles2[k] - 1), (Tailles3[k] - 1));
			ScrutationsMultiples(Phases, Transitions);
	
	
	
			EteindrePoint((Tailles1[k - 1] - 1), (Tailles2[k - 1] - 1), (Tailles0[k - 1] - 1));
			ScrutationsMultiples(Phases, Transitions);
	
			AfficherPoint((Tailles1[k] - 1), (Tailles2[k] - 1), (Tailles0[k] - 1));
			ScrutationsMultiples(Phases, Transitions);
	
	
	
			EteindrePoint((Tailles2[k - 1] - 1), (Tailles0[k - 1] - 1), (Tailles3[k - 1] - 1));
			ScrutationsMultiples(Phases, Transitions);
	
			AfficherPoint((Tailles2[k] - 1), (Tailles0[k] - 1), (Tailles3[k] - 1));
			ScrutationsMultiples(Phases, Transitions);
		}
	}
}



void EffetCubeBaladeur(unsigned char Phases, unsigned char Arete, unsigned char Transitions)
{
	unsigned char l;

		EteindreCube();
		AfficherParallelepipede(0, 0, 0, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(0, 0, 1, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(0, 0, 3, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
		EteindreCube();
		AfficherParallelepipede(0, 0, (8 - Arete), Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}



		EteindreCube();
		AfficherParallelepipede(1, 0, (8 - Arete), Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(3, 0, (8 - Arete), Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede((8 - Arete), 0, (8 - Arete), Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}


		EteindreCube();
		AfficherParallelepipede((8 - Arete), 0, 3, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede((8 - Arete), 0, 1, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede((8 - Arete), 0, 0, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}



		EteindreCube();
		AfficherParallelepipede((8 - Arete), 1, 0, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede((8 - Arete), 3, 0, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede((8 - Arete), (8 - Arete), 0, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}



		EteindreCube();
		AfficherParallelepipede((8 - Arete), (8 - Arete), 1, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede((8 - Arete), (8 - Arete), 3, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede((8 - Arete), (8 - Arete), (8 - Arete), Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}



		EteindreCube();
		AfficherParallelepipede(3, (8 - Arete), (8 - Arete), Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(1, (8 - Arete), (8 - Arete), Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(0, (8 - Arete), (8 - Arete), Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}



		EteindreCube();
		AfficherParallelepipede(0, (8 - Arete), 3, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(0, (8 - Arete), 1, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(0, (8 - Arete), 0, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}



		EteindreCube();
		AfficherParallelepipede(0, 3, 0, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(0, 1, 0, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}

		EteindreCube();
		AfficherParallelepipede(0, 0, 0, Arete, Arete, Arete);
		for(l = 0; l < Phases; l++)
		{
			Scrutation(Transitions);
		}
}



void EffetColonneVariable(unsigned char Phases, unsigned char Arete, unsigned char Transitions)
{
	unsigned char k;
	unsigned char l;

		for(k = 0; k < 64; k++)
		{
			EteindreCube();
			AfficherParallelepipede((Tailles0[k] - 1), (Tailles1[k] - 1), 0, Tailles0[k], Tailles1[k], Tailles0[k]);
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 0; k < 64; k++)
		{
			EteindreCube();
			AfficherParallelepipede((Tailles1[k] - 1), (Tailles2[k] - 1), 0, Tailles1[k], Tailles2[k], Tailles1[k]);
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 0; k < 64; k++)
		{
			EteindreCube();
			AfficherParallelepipede((Tailles2[k] - 1), (Tailles3[k] - 1), 0, Tailles2[k], Tailles3[k], Tailles2[k]);
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}

		for(k = 0; k < 64; k++)
		{
			EteindreCube();
			AfficherParallelepipede((Tailles3[k] - 1), (Tailles2[k] - 1), 0, Tailles3[k], Tailles0[k], Tailles3[k]);
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
}


void EffetImbriquesVariables(unsigned char Phases, unsigned char Arete, unsigned char Transitions)
{
	unsigned char k;
	unsigned char l;


		for(k = 0; k < 64; k++)
		{
			EteindreCube();
			AfficherParallelepipede(2, 2, 0, 4, 4, Tailles0[k]);
			AfficherParallelepipede(0, 0, 0, 8, 8, Tailles1[k]);
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
}



void EffetMultiplesVariables(unsigned char Phases, unsigned char Arete, unsigned char Transitions)
{
	unsigned char k;
	unsigned char l;

		for(k = 0; k < 64; k++)
		{
			EteindreCube();
			AfficherParallelepipede(0, 0, 0, 2, 2, Tailles0[k]);
			AfficherParallelepipede(6, 0, 0, 2, 2, Tailles1[k]);
			AfficherParallelepipede(0, 6, 0, 2, 2, Tailles2[k]);
			AfficherParallelepipede(6, 6, 0, 2, 2, Tailles3[k]);

			AfficherParallelepipede(3, 3, 0, 2, 2, ((Tailles1[k] + Tailles0[k]) / 2));

			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
}



void EffetMultitudeVariables(unsigned char Phases, unsigned char Arete, unsigned char Transitions)
{
	unsigned char k;
	unsigned char l;

		for(k = 0; k < 64; k++)
		{
			EteindreCube();
			AfficherParallelepipede(0, 0, 0, 2, 2, Tailles0[k]);
			AfficherParallelepipede(6, 0, 0, 2, 2, Tailles1[k]);
			AfficherParallelepipede(0, 6, 0, 2, 2, Tailles2[k]);
			AfficherParallelepipede(6, 6, 0, 2, 2, Tailles3[k]);

			AfficherParallelepipede(3, 3, 0, 2, 2, ((Tailles1[k] + Tailles0[k]) / 2));

			AfficherParallelepipede(0, 3, 0, 2, 2, ((Tailles2[k] + Tailles1[k]) / 2));
			AfficherParallelepipede(3, 0, 0, 2, 2, ((Tailles3[k] + Tailles2[k]) / 2));
			AfficherParallelepipede(6, 3, 0, 2, 2, ((Tailles1[k] + Tailles2[k]) / 2));
			AfficherParallelepipede(3, 6, 0, 2, 2, ((Tailles2[k] + Tailles0[k]) / 2));

			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
}



void EffetHauteurVariable(unsigned char Phases, unsigned char Arete, unsigned char Transitions)
{
	unsigned char k;
	unsigned char l;

	unsigned char Position = 0;

	switch(Arete)
	{
		case 2 :
		{
			Position = 3;
			break;
		}
		case 4 :
		{
			Position = 2;
			break;
		}
		case 6 :
		{
			Position = 1;
			break;
		}
		case 8 :
		{
			Position = 0;
			break;
		}
		default :
		{
			break;
		}
	}

		for(k = 0; k < 64; k++)
		{
			EteindreCube();
			AfficherParallelepipede(Position, Position, 0, Arete, Arete, Tailles0[k]);
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
}



void EffetHauteursVariables(unsigned char Phases, unsigned char Arete, unsigned char Transitions)
{
	unsigned char k;
	unsigned char l;

		for(k = 0; k < 64; k++)
		{
			EteindreCube();
			AfficherParallelepipede(0, 0, 0, Arete, Arete, Tailles0[k]);
			AfficherParallelepipede((8 - Arete), 0, 0, Arete, Arete, Tailles1[k]);
			AfficherParallelepipede(0, (8 - Arete), 0, Arete, Arete, Tailles2[k]);
			AfficherParallelepipede((8 - Arete), (8 - Arete), 0, Arete, Arete, Tailles3[k]);
			for(l = 0; l < Phases; l++)
			{
				Scrutation(Transitions);
			}
		}
}




