


#include <p18f2610.h>



#include <i2c.h>



#include "h/I2C.h"
#include "h/USART.h"
#include "h/Affichages.h"
#include "h/Effets.h"
#include "h/Thermometre.h"
#include "h/Parametres.h"
#include "h/Utilitaires.h"



#pragma config WDTPS = 32768	/* Prdiviseur du watchdog. */
#pragma config LVP = OFF	/* Low Voltage Programming dsactiv => RB5 I/O normale. */
#pragma config DEBUG = OFF	/* Dbug dsactiv => RB6 et RB7 normal I/O. */
#pragma config IESO = OFF	/* Oscillator Switchover mode dsactiv. */
#pragma config FCMEN = OFF	/* Fail-Safe Clock dsactiv. */
#pragma config WDT = OFF	/* Watchdog dsactiv. */
#pragma config PBADEN = OFF	/* PORTB<4> and PORTB<1:0> Configured as Digital I/O Pins on Reset. */
#pragma config XINST = OFF	/* Instruction set extension and Indexed Addressing mode disabled (Legacy mode). */
#pragma config STVREN = OFF	/* Pas de reset du  la pile. */

#pragma config BOREN = OFF
#pragma config MCLRE = OFF
#pragma config OSC = INTIO67



unsigned char g_Affichages[NOMBRE_ETAGES][NOMBRE_COLONNES] = {0x00};



unsigned char g_Sortie = 0x00;



unsigned char g_Maintient = 0x00;



unsigned char Mot[8] = {0x00, 0x00, '.', '0', (5 + '{'), 'C', 0x00, 0x00};



const rom unsigned char Texte[] = "BONJOUR !\n";



void InitialisationMicrocontroleur(void);
void main(void);



void InitialisationMicrocontroleur(void)
{
	OSCCON = 0xFF;
	OSCTUNE = 0x00;
	CCP1CON = 0;
	ADCON1 = 0x0F; 	
}



void main(void)
{
	unsigned char k, l, m, v, i;

	unsigned char Colonne;	/* Variable qui indique  quelle colonne les donnes sont envoyes. */
	unsigned char Etage;	/* Variable qui indique  quel tage les donnes sont envoyes. */



	unsigned char E1 = 0x00;
	unsigned char E2 = 0x00;



	g_Sortie = 0;



	InitialisationMicrocontroleur();



	INTCONbits.GIE = 0;	/* Dsactivation gnrale des interruptions du microcontrleur PIC18F2610. */



	DIRECTION_ENTREE_ANALOGIQUE_1 = 1;
	DIRECTION_ENTREE_ANALOGIQUE_2 = 1;

	DIRECTION_BOUTON_1 = 1;
	DIRECTION_BOUTON_2 = 1;
	DIRECTION_BOUTON_3 = 1;

	DIRECTIONS_DONNEES = 0x00;
	
	DIRECTION_VALIDATIONS = 0;
	DIRECTION_RAZ = 0;
	DIRECTION_ACTIVATIONS = 0;

	DIRECTION_I2C_SCL = 1;
	DIRECTION_I2C_SDA = 1;

	RCSTAbits.SPEN = 1;
	RCSTAbits.CREN = 1;
	TRISCbits.TRISC7 = 1;
	TRISCbits.TRISC6 = 0;


	BAUDCONbits.BRG16 = 0;
	TXSTAbits.SYNC = 0;
	SPBRGH = 0;
	SPBRG = 12;



	TXSTAbits.TXEN = 1;



	OpenI2C(MASTER, SLEW_OFF);



	SSPADD = 99;



	ConfigurerUnCapteur(ADRESSE_CAPTEUR);



	BROCHES_DONNEES = 0x00;
	BROCHE_VALIDATIONS = 0;
	BROCHE_ACTIVATIONS = 1;
	BROCHE_RAZ = 1;
	BROCHE_RAZ = 0;



	PositionnerCompteurs(7, 7);



	INTCONbits.GIE = 1;	/* Autorisation gnrale des interruptions du microcontrleur PIC18F2610. */



	INTCONbits.PEIE = 1;



	PIE1bits.RCIE = 1;



	EnvoyerTexteUSART("CUBE A LED, VERSION 1.\r\0");



	EnvoyerTexteUSART("CONNEXION USART FONCTIONNELLE.\r\0");



	EteindreCube();



	while(1)
	{
/* -------------------------------- Dbut de l'effet -------------------------------- */
	
		do
		{
			for(v = 'X'; v <= 'Z'; v++)
			{
				BalayerTranches(2, v, 90);
				BalayerTranches(3, v, 90);
				BalayerTranches(6, v, 90);
				BalayerTranches(3, v, 90);
				BalayerTranches(2, v, 90);
			}
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			for(v = 'X'; v <= 'Z'; v++)
			{
				RemplirTranches(2, v, 90);
				RemplirTranches(3, v, 90);
				RemplirTranches(6, v, 90);
				RemplirTranches(3, v, 90);
				RemplirTranches(2, v, 90);
			}
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			for(k = 10; k < 50; k = (k + 20))
			{
				for(v = 1; v <= 6; v++)
				{
					EteindreCube();
					ActiverOblique(v, 0xFF);
					ScrutationsMultiples(10, 90);
				}
			}
	
			for(k = 50; k > 10; k = (k - 20))
			{
				for(v = 1; v <= 6; v++)
				{
					EteindreCube();
					ActiverOblique(v, 0xFF);
					ScrutationsMultiples(10, 90);
				}
			}
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			for(k = 0; k < 3; k++)
			{
				EteindreCube();
				ActiverTranche('Y', 3, 0xFF);
				ActiverTranche('Y', 4, 0xFF);
				ScrutationsMultiples(10, 90);
		
				EteindreCube();
				ActiverOblique(1, 0xFF);
				ScrutationsMultiples(10, 90);
		
				EteindreCube();
				ActiverTranche('X', 3, 0xFF);
				ActiverTranche('X', 4, 0xFF);
				ScrutationsMultiples(10, 90);
		
				EteindreCube();
				ActiverOblique(2, 0xFF);
				ScrutationsMultiples(10, 90);
		
				EteindreCube();
				ActiverTranche('Y', 3, 0xFF);
				ActiverTranche('Y', 4, 0xFF);
				ScrutationsMultiples(10, 90);
		
				EteindreCube();
				ActiverOblique(1, 0xFF);
				ScrutationsMultiples(10, 90);
		
				EteindreCube();
				ActiverTranche('X', 3, 0xFF);
				ActiverTranche('X', 4, 0xFF);
				ScrutationsMultiples(10, 90);
		
				EteindreCube();
				ActiverOblique(2, 0xFF);
				ScrutationsMultiples(10, 90);
			}



			EteindreCube();
			ActiverTranche('Y', 3, 0xFF);
			ActiverTranche('Y', 4, 0xFF);
			ScrutationsMultiples(10, 90);
	
	

			EteindreCube();
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			CroiserTranches(10, 90);
		}
		while((g_Sortie == 0) && (g_Maintient == 1));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		AllumerCube();



		do
		{
			for(k = 0; k < 3; k++)
			{
				ScrutationsIntensitesVariables(10, 100, 1);
			}
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));
	
	
	
		EteindreCube();

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			EffetPointsVariables(1, 0, 10);
			EffetPointsVariables(7, 0, 10);
			EffetPointsVariables(1, 0, 10);
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));
	
	
	
		EteindreCube();

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			for(v = 2; v <= 10; (v = v + 3))
			{
				EffetLignes(v, 90);	
			}
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			EffetSurfaces(10, 90);
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			EffetSerpent(3, 90);
			EffetSerpent(10, 90);
			EffetSerpent(3, 90);
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			for(k = 10; k > 2; k = (k - 2))
			{
				EffetGrosseHelice(k, 0, 90);
			}
	
			for(k = 2; k < 10; k = (k + 2))
			{
				EffetGrosseHelice(k, 0, 90);
			}
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			for(k = 10; k > 2; k = (k - 2))
			{
				EffetPetitesHelices(k, 0, 90);
			}
	
			for(k = 2; k < 10; k = (k + 2))
			{
				EffetPetitesHelices(k, 0, 90);
			}
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			for(k = 1; k < 3; k++)
			{
				for(v = 1; v <= 6; v++)
				{
					EteindreCube();
					ActiverOblique(v, 0x55);
					ScrutationsMultiples(10, 90);
				}
			}
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			for(k = 1; k <= 3; k++)
			{
				for(l = 1; l <= 8; l++)
				{
					for(v = 1; v < 8; v++)
					{
						AfficherCoin(v, l, k);
					
						ScrutationsMultiples(3, 90);
					
						EteindreCube();
					}
			
					for(v = 8; v > 0; v--)
					{
						AfficherCoin(v, l, k);
					
						ScrutationsMultiples(3, 90);
					
						EteindreCube();
					}
				}
				for(v = 1; v < 4; v++)
				{
					EffetCoins(30, v, k, 90);
				}
				for(v = 4; v >= 1; v--)
				{
					EffetCoins(30, v, k, 90);
				}
			}
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));
	
	
	
		EteindreCube();

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			for(v = 2; v <= 3; v++)
			{
				EffetCoins(30, v, 0x01, 90);
			}
	
	
	
			EffetCubeCentre(10, 0, 90);
	
	
	
			for(l = 5; l < 15; (l = l + 5))
			{
				EffetCubeCentre(l, 1, 90);
				EffetCubeCentre(l, 0, 90);
			}
			for(l = 15; l > 0; (l = l - 5))
			{
				EffetCubeCentre(l, 1, 90);
				EffetCubeCentre(l, 0, 90);
			}
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));
	
	
	
		EteindreCube();

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			AfficherParallelepipede(2, 2, 2, 2, 2, 2);
			ScrutationsMultiples(7, 90);
	
			EteindreCube();
			AfficherParallelepipede(1, 1, 1, 2, 2, 2);
			ScrutationsMultiples(7, 90);
	
			EteindreCube();
			AfficherParallelepipede(0, 0, 0, 2, 2, 2);
			ScrutationsMultiples(7, 90);
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			EffetCubeVariable(5, 0, 90);
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));
	
	
	
		EteindreCube();

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			AfficherParallelepipede(0, 0, 0, 1, 1, 1);
			ScrutationsMultiples(7, 90);
	
			EteindreCube();
			AfficherParallelepipede(0, 0, 0, 2, 2, 2);
			ScrutationsMultiples(7, 90);
			
			AfficherParallelepipede(0, 0, 0, 3, 3, 3);
			ScrutationsMultiples(7, 90);
			
			AfficherParallelepipede(0, 0, 0, 4, 4, 4);
			ScrutationsMultiples(7, 90);
	
			
	
			EffetCubeBaladeur(10, 5, 90);
			EffetCubeBaladeur(9, 5, 90);
			EffetCubeBaladeur(8, 4, 90);
			EffetCubeBaladeur(7, 4, 90);
			EffetCubeBaladeur(6, 3, 90);
			EffetCubeBaladeur(5, 3, 90);
			EffetCubeBaladeur(4, 3, 90);
			EffetCubeBaladeur(3, 2, 90);
			EffetCubeBaladeur(2, 2, 90);
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			EffetColonneVariable(3, 0, 90);
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			EffetHauteurVariable(3, 4, 90);
			EffetHauteurVariable(3, 6, 90);
			EffetHauteurVariable(3, 8, 90);
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			EffetImbriquesVariables(3, 8, 90);
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			EffetHauteursVariables(3, 4, 90);
			EffetHauteursVariables(3, 3, 90);
			EffetHauteursVariables(3, 2, 90);
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			EffetMultiplesVariables(3, 2, 90);
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			EffetMultitudeVariables(3, 2, 90);
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			for(k = 1; k <= 14; k++)
			{
				AfficherCoin(k, 1, 2);
			
				ScrutationsMultiples(3, 90);
			
				EteindreCube();
			}
	
	
	
			for(k = 8; k > 0; k--)
			{
				AfficherCoin(k, 8, 2);
			
				ScrutationsMultiples(3, 90);
			
				EteindreCube();
			}
	
	
			for(k = 1; k <= 14; k++)
			{
				AfficherCoin(k, 2, 2);
			
				ScrutationsMultiples(3, 90);
			
				EteindreCube();
			}
	
	
	
			for(k = 8; k > 0; k--)
			{
				AfficherCoin(k, 7, 2);
			
				ScrutationsMultiples(3, 90);
			
				EteindreCube();
			}
	
			for(k = 1; k <= 8; k++)
			{
				AfficherCoin(k, 3, 2);
			
				ScrutationsMultiples(3, 90);
			
				EteindreCube();
			}
	
	
	
			for(k = 14; k > 0; k--)
			{
				AfficherCoin(k, 6, 2);
			
				ScrutationsMultiples(3, 90);
			
				EteindreCube();
			}
	
	
			for(k = 1; k <= 8; k++)
			{
				AfficherCoin(k, 4, 2);
			
				ScrutationsMultiples(3, 90);
			
				EteindreCube();
			}
	
	
	
			for(k = 14; k > 0; k--)
			{
				AfficherCoin(k, 5, 2);
			
				ScrutationsMultiples(3, 90);
			
				EteindreCube();
			}
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			for(l = 0; l <= 7; l++)
			{
				EteindreCube();
	
				AfficherCaractere(1, 7, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();


				AfficherCaractere(1, 6, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();
	


				AfficherCaractere(1, 5, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();


	
				AfficherCaractere(1, 4, 0, 'Y', 0, 0, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();
	
	
	
				AfficherCaractereOblique(0, 0, 1, 2, 0, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();
	
	
	
				AfficherCaractere(4, 0, 0, 'X', 2, 1, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();

	
	
				AfficherCaractereOblique(0, 0, 2, 2, 1, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();
	
	

				AfficherCaractere(0, 4, 0, 'Y', 0, 1, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();
	
	
	
				AfficherCaractereOblique(0, 0, 1, 2, 1,  Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();

	
	
				AfficherCaractere(4, 0, 0, 'X', 0, 0, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();
	
	
	
				AfficherCaractereOblique(0, 0, 2, 2, 0, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();



				AfficherCaractere(1, 4, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();


				AfficherCaractere(1, 3, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();



				AfficherCaractere(1, 2, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();



				AfficherCaractere(1, 1, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();



				AfficherCaractere(1, 0, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();



			}



				l = 8;



				EteindreCube();
		
		
				ScrutationsMultiples(30, 90);

				EteindreCube();
	
				AfficherCaractere(1, 7, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();


				AfficherCaractere(1, 6, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();
	


				AfficherCaractere(1, 5, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();


	
				AfficherCaractere(1, 4, 0, 'Y', 0, 0, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();
	
	
	
				AfficherCaractereOblique(0, 0, 1, 2, 0, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();
	
	
	
				AfficherCaractere(4, 0, 0, 'X', 2, 1, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();

	
	
				AfficherCaractereOblique(0, 0, 2, 2, 1, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();
	
	

				AfficherCaractere(0, 4, 0, 'Y', 0, 1, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();
	
	
	
				AfficherCaractereOblique(0, 0, 1, 2, 1,  Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();

	
	
				AfficherCaractere(4, 0, 0, 'X', 0, 0, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();
	
	
	
				AfficherCaractereOblique(0, 0, 2, 2, 0, Texte[l]);
	
				ScrutationsMultiples(6, 90);
	
				EteindreCube();



				AfficherCaractere(1, 4, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();


				AfficherCaractere(1, 3, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();



				AfficherCaractere(1, 2, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();



				AfficherCaractere(1, 1, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();



				AfficherCaractere(1, 0, 0, 'Y', 0, 0, Texte[l]);

				ScrutationsMultiples(6, 90);

				EteindreCube();

		
		
				ScrutationsMultiples(30, 90);



				Delai(3000);



		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



/* -------------------------------- Dbut de l'effet -------------------------------- */

		do
		{
			for(k = 0; k < 3; k++)
			{
				l = 0;
	
	
	
				Mot[0] = 0x00;
				Mot[1] = 0x00;
				Mot[2] = '.';
				Mot[3] = '0';
				Mot[4] = (5 + '{');
				Mot[5] = 'C';
				Mot[6] = 0x00;
				Mot[7] = 0x00;
		
	
	
				Read16nouvelle(ADRESSE_CAPTEUR, 0x00, (0x01 | ADRESSE_CAPTEUR), &E1, &E2);
	
	
	
				ConvertirAfficherGraphique(E1, 10, 0x00);
		
	
	
				Mot[3] = (0x30 + (((0xF0 & E2) >> 4) / 1.6));
		
		
		
				while(Mot[l] != 0x00)
				{
					EteindreCube();
		
					AfficherCaractere(1, 0, 0, 'Z', 0, 0, Mot[l]);
		
					ScrutationsMultiples(10, 90);
		
		
		
					EteindreCube();
		
					AfficherCaractereOblique(1, 0, 5, 0, 0, Mot[l]);
		
					ScrutationsMultiples(10, 90);
		
		
		
					EteindreCube();
		
					AfficherCaractere(1, 0, 0, 'Y', 0, 0, Mot[l]);
		
					ScrutationsMultiples(10, 90);
		
		
		
					EteindreCube();
		
		
		
					ScrutationsMultiples(10, 90);
					
		
		
					l++;
				}
		
		
		
				EteindreCube();
		
		
				ScrutationsMultiples(30, 90);
			}
		}
		while((g_Sortie == 0x00) && (g_Maintient == 0xFF));

/* -------------------------------- Fin de l'effet -------------------------------- */



		g_Sortie = 0x00;



	}

	EteindreCube();



	AfficherCaractere(0, 1, 0, 'X', 0, 0, '1');
	AfficherCaractere(1, 7, 0, 'X', 0, 0, '6');
	AfficherCaractere(0, 0, 1, 'Y', 0, 1, '2');
	AfficherCaractere(7, 0, 2, 'Y', 0, 0, '5');
	AfficherCaractere(1, 0, 0, 'Z', 0, 0, '3');
	AfficherCaractere(1, 0, 7, 'Z', 0, 0, '4');

	while(1)
	{
		Scrutation(90);
	}

	while(1)
	{
		for(l = 0; l < 106; l++)
		{
			for(m = 0; m < NOMBRE_ETAGES; m++)
			{
				AfficherCaractere0(m, 0, 'C');

				for(k = 0; k < 3; k++)
				{
					Scrutation(90);
				}
			}

			for(m = 0; m < NOMBRE_ETAGES; m++)
			{
				AfficherCaractere1(m, 0, 'C');

				for(k = 0; k < 3; k++)
				{
					Scrutation(90);
				}
			}
		}

	}
}



/* Routines d'interruptions. */
#pragma interrupt InterruptHandler


 
void InterruptHandler (void)
{
	static unsigned char Etg = 0;
	static unsigned char Col = 0;

	if(PIE1bits.RCIE && PIR1bits.RCIF)
	{
		g_Affichages[Etg][Col] = RCREG;

		if(Col < 7)
		{
			Col++;
		}
		else
		{
			Col = 0;
			if(Etg < 7)
			{
				Etg++;
			}
			else
			{
				Etg = 0;
				EnvoyerParUSART('I');
			}
		}
		PIR1bits.RCIF = 0;
	}
}



#pragma code InterruptVectorHigh = 0x08	/* Placer le code suivant  l'adresse 0x08, dans la mmoire du programme du microcontrleur PIC18F2610. */



void InterruptVectorHigh (void)
{
	_asm
	goto InterruptHandler	/* Jump to interrupt routine. */
	_endasm
}


